#version 100
precision highp float;
#define _gl4es_MaxLights 8
precision highp int;
varying mediump vec4 _gl4es_TexCoord_0;
struct _gl4es_LightSourceParameters
{
   vec4 ambient;
   vec4 diffuse;
   vec4 specular;
   vec4 position;
   vec4 halfVector;
   vec3 spotDirection;
   float spotExponent;
   float spotCutoff;
   float spotCosCutoff;
   float constantAttenuation;
   float linearAttenuation;
   float quadraticAttenuation;
};
uniform _gl4es_LightSourceParameters _gl4es_LightSource[_gl4es_MaxLights];
struct _gl4es_LightModelParameters {
  vec4 ambient;
};
uniform _gl4es_LightModelParameters _gl4es_LightModel;
struct _gl4es_FogParameters {
    lowp vec4 color;
    mediump float density;
    highp   float start;
    highp   float end;
    highp   float scale;
};
uniform _gl4es_FogParameters _gl4es_Fog;
float clamp(float f, int a, int b) {
 return clamp(f, float(a), float(b));
}
float clamp(float f, float a, int b) {
 return clamp(f, a, float(b));
}
float clamp(float f, int a, float b) {
 return clamp(f, float(a), b);
}
vec2 clamp(vec2 f, int a, int b) {
 return clamp(f, float(a), float(b));
}
vec2 clamp(vec2 f, float a, int b) {
 return clamp(f, a, float(b));
}
vec2 clamp(vec2 f, int a, float b) {
 return clamp(f, float(a), b);
}
vec3 clamp(vec3 f, int a, int b) {
 return clamp(f, float(a), float(b));
}
vec3 clamp(vec3 f, float a, int b) {
 return clamp(f, a, float(b));
}
vec3 clamp(vec3 f, int a, float b) {
 return clamp(f, float(a), b);
}
vec4 clamp(vec4 f, int a, int b) {
 return clamp(f, float(a), float(b));
}
vec4 clamp(vec4 f, float a, int b) {
 return clamp(f, a, float(b));
}
vec4 clamp(vec4 f, int a, float b) {
 return clamp(f, float(a), b);
}
float max(float a, int b) {
 return max(a, float(b));
}
float max(int a, float b) {
 return max(float(a), b);
}
uniform sampler2D Texture0, Texture1, Texture2, Texture3;
varying vec3 Normal;
varying float fogFactor;
varying vec4 Position;

vec4 CelShading(int l)
{

        vec4 texel0 = texture2D(Texture0, vec2(_gl4es_TexCoord_0));
        vec4 texel1 = texture2D(Texture1, vec2(_gl4es_TexCoord_0));
        vec4 texel2 = texture2D(Texture2, vec2(_gl4es_TexCoord_0));
        vec4 texel3 = texture2D(Texture3, vec2(_gl4es_TexCoord_0));
        vec4 color = _gl4es_LightModel.ambient * texel0;


        float t1Total = texel1.r + texel1.g + texel1.b;
        float t2Total = texel2.r + texel2.g + texel2.b;
        float t3Total = texel3.r + texel3.g + texel3.b;

        if (t2Total > 0.00000) color = _gl4es_LightModel.ambient * vec4(0.500000, 0.00000, 0.00000, 1.00000) * t2Total / 3.00000;
        else if (t1Total >= 1.00000) color = _gl4es_LightModel.ambient * vec4(0.500000, 0.00000, 0.00000, 1.00000);
        else if (t3Total >= 1.00000) color = _gl4es_LightModel.ambient * vec4(0.400000, 0.372500, 0.321500, 1.00000);


        vec3 LightDir = vec3(_gl4es_LightSource[l].position-Position);
        float dotProduct = max(dot(normalize(LightDir), normalize(Normal)), 0.00000);


        float dist = length(LightDir);
        float att = 1.00000 / (_gl4es_LightSource[l].constantAttenuation + _gl4es_LightSource[l].quadraticAttenuation * dist * dist);
        att *= 500.000;


        float toonFactor = dotProduct;
        toonFactor *= att;
        if (toonFactor < 0.200000) toonFactor = clamp(toonFactor, 0.00000, 0.0500000);
        else if (toonFactor < 0.500000) toonFactor = clamp(toonFactor, 0.200000, 0.350000);
        else if (toonFactor < 0.950000) toonFactor = clamp(toonFactor, 0.500000, 0.650000);
        else toonFactor = clamp(toonFactor, 0.950000, 1.00000);


        vec4 diffuse = _gl4es_LightSource[l].diffuse;
        diffuse /= vec4(128, 128, 128, 1.00000);

        if (t2Total > 0.00000) color += toonFactor * diffuse * vec4(0.500000, 0.00000, 0.00000, 1.00000) * t2Total / 3.00000;
        else if (t1Total >= 1.00000) color += toonFactor * diffuse * vec4(0.500000, 0.00000, 0.00000, 1.00000);
        else if (t3Total >= 1.00000) color += toonFactor * diffuse * vec4(0.400000, 0.372500, 0.321500, 1.00000);
        else color += toonFactor * diffuse * texture2D(Texture0, vec2(_gl4es_TexCoord_0));

        return color;
}


void main()
{
        vec4 color = vec4(0.00000, 0.00000, 0.00000, 0.00000);

        for (int i = 0; i < _gl4es_MaxLights; i++)
        {
                color += CelShading(i);
        }


        vec4 texColor = texture2D(Texture0, vec2(_gl4es_TexCoord_0));
        if (texColor.r >= 1.00000 && texColor.g <= 0.00000 && texColor.b <= 0.00000)
        {
                color = vec4(0.250000, 0.00000, 0.00000, 1.00000);
        }


        vec3 eyePos = normalize(vec3(-Position));
        float fresnel = max(dot(normalize(Normal), eyePos), 0.00000);
        if (fresnel < 0.400000)
        {
                float rim = clamp((0.400000 - fresnel) / 0.400000, 0.00000, 1.00000);
                color += color * rim;
        }

        color = mix(_gl4es_Fog.color, color, fogFactor);
        gl_FragColor = color;
}
